/*
================================================================================
  RPL/2 (R) version 4.1.21
  Copyright (C) 1989-2015 Dr. BERTRAND Jol

  This file is part of RPL/2.

  RPL/2 is free software; you can redistribute it and/or modify it
  under the terms of the CeCILL V2 License as published by the french
  CEA, CNRS and INRIA.
 
  RPL/2 is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE.  See the CeCILL V2 License
  for more details.
 
  You should have received a copy of the CeCILL License
  along with RPL/2. If not, write to info@cecill.info.
================================================================================
*/


#include "rpl-conv.h"


/*
================================================================================
  Fonction 'max'
================================================================================
  Entres :
--------------------------------------------------------------------------------
  Sorties :
--------------------------------------------------------------------------------
  Effets de bord : nant
================================================================================
*/

void
instruction_max(struct_processus *s_etat_processus)
{
	real8						max_reel;
	real8						module;

	integer8					max_entier;

	struct_liste_chainee		*l_element_courant;
	struct_liste_chainee		*l_element_precedent;

	struct_objet				*s_copie_argument_1;
	struct_objet				*s_copie_argument_2;
	struct_objet				*s_objet_argument_1;
	struct_objet				*s_objet_argument_2;
	struct_objet				*s_objet_position;
	struct_objet		 		*s_objet_resultat;

	integer8					i;
	integer8					j;
	integer8					nombre_elements;
	integer8					position_max_i;
	integer8					position_max_j;

	(*s_etat_processus).erreur_execution = d_ex;

	if ((*s_etat_processus).affichage_arguments == 'Y')
	{
		printf("\n  MAX ");

		if ((*s_etat_processus).langue == 'F')
		{
			printf("(maximum)\n\n");
		}
		else
		{
			printf("(maximum)\n\n");
		}

		printf("    1: %s, %s, %s\n", d_VIN, d_VRL, d_VCX);
		printf("->  2: %s, %s, %s\n", d_INT, d_REL, d_CPL);
		printf("    1: %s\n\n", d_LST);

		printf("    1: %s, %s, %s\n", d_MIN, d_MRL, d_MCX);
		printf("->  2: %s, %s, %s\n", d_INT, d_REL, d_CPL);
		printf("    1: %s\n\n", d_LST);

		printf("    2: %s, %s\n", d_INT, d_REL);
		printf("    1: %s, %s\n", d_INT, d_REL);
		printf("->  1: %s, %s\n\n", d_INT, d_REL);

		printf("    2: %s, %s, %s, %s, %s\n",
				d_INT, d_REL, d_NOM, d_ALG, d_RPN);
		printf("    1: %s, %s, %s, %s, %s\n",
				d_INT, d_REL, d_NOM, d_ALG, d_RPN);
		printf("->  1: %s, %s\n", d_ALG, d_RPN);

		return;
	}
	else if ((*s_etat_processus).test_instruction == 'Y')
	{
		(*s_etat_processus).nombre_arguments = 2;
		return;
	}

/*
--------------------------------------------------------------------------------
  MAX portant sur un tableau (un seul argument)
--------------------------------------------------------------------------------
*/

	if (((*(*(*s_etat_processus).l_base_pile).donnee).type == VIN)
			|| ((*(*(*s_etat_processus).l_base_pile).donnee).type ==
			VRL) || ((*(*(*s_etat_processus).l_base_pile)
			.donnee).type == VCX)) 
	{
		if (test_cfsf(s_etat_processus, 31) == d_vrai)
		{
			if (empilement_pile_last(s_etat_processus, 1) == d_erreur)
			{
				return;
			}
		}

		if (depilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				&s_objet_argument_1) == d_erreur)
		{
			(*s_etat_processus).erreur_execution = d_ex_manque_argument;
			return;
		}

		if ((s_objet_position = allocation(s_etat_processus, LST)) == NULL)
		{
			(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
			return;
		}

		/*
		 * Vecteur d'entiers
		 */

		if ((*s_objet_argument_1).type == VIN)
		{
			max_entier = ((integer8 *) (*((struct_vecteur *)
					(*s_objet_argument_1).objet)).tableau)[0];
			position_max_i = 0;

			for(i = 1; i < (*((struct_vecteur *) (*s_objet_argument_1).objet))
					.taille; i++)
			{
				if (((integer8 *) (*((struct_vecteur *) (*s_objet_argument_1)
						.objet)).tableau)[i] > max_entier)
				{
					max_entier = ((integer8 *) (*((struct_vecteur *)
							(*s_objet_argument_1).objet)).tableau)[i];
					position_max_i = i;
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, INT))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*s_objet_resultat).objet)) = max_entier;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_i + 1;
		}

		/*
		 * Vecteur de rels
		 */

		else if ((*s_objet_argument_1).type == VRL)
		{
			max_reel = ((real8 *) (*((struct_vecteur *)
					(*s_objet_argument_1).objet)).tableau)[0];
			position_max_i = 0;

			for(i = 1; i < (*((struct_vecteur *) (*s_objet_argument_1).objet))
					.taille; i++)
			{
				if (((real8 *) (*((struct_vecteur *) (*s_objet_argument_1)
						.objet)).tableau)[i] > max_reel)
				{
					max_reel = ((real8 *) (*((struct_vecteur *)
							(*s_objet_argument_1).objet)).tableau)[i];
					position_max_i = i;
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, REL))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((real8 *) (*s_objet_resultat).objet)) = max_reel;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_i + 1;
		}

		/*
		 * Vecteur de complexes
		 */

		else
		{
			f77absc_(&(((struct_complexe16 *) (*((struct_vecteur *)
					(*s_objet_argument_1).objet)).tableau)[0]), &max_reel);

			position_max_i = 0;

			for(i = 1; i < (*((struct_vecteur *) (*s_objet_argument_1).objet))
					.taille; i++)
			{
				f77absc_(&(((struct_complexe16 *) (*((struct_vecteur *)
						(*s_objet_argument_1).objet)).tableau)[i]), &module);

				if (module > max_reel)
				{
					max_reel = module;
					position_max_i = i;
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, CPL))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_complexe16 *) (*s_objet_resultat).objet))
					.partie_reelle = ((struct_complexe16 *)
					(*((struct_vecteur *) (*s_objet_argument_1).objet))
					.tableau)[position_max_i].partie_reelle;
			(*((struct_complexe16 *) (*s_objet_resultat).objet))
					.partie_imaginaire = ((struct_complexe16 *)
					(*((struct_vecteur *) (*s_objet_argument_1).objet))
					.tableau)[position_max_i].partie_imaginaire;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_i + 1;
		}

		liberation(s_etat_processus, s_objet_argument_1);

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_resultat) == d_erreur)
		{
			return;
		}

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_position) == d_erreur)
		{
			return;
		}
	}
	else if (((*(*(*s_etat_processus).l_base_pile).donnee).type ==
			MIN) || ((*(*(*s_etat_processus).l_base_pile)
			.donnee).type == MRL) || ((*(*(*s_etat_processus)
			.l_base_pile).donnee).type == MCX)) 
	{
		if (test_cfsf(s_etat_processus, 31) == d_vrai)
		{
			if (empilement_pile_last(s_etat_processus, 1) == d_erreur)
			{
				return;
			}
		}

		if (depilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				&s_objet_argument_1) == d_erreur)
		{
			(*s_etat_processus).erreur_execution = d_ex_manque_argument;
			return;
		}

		if ((s_objet_position = allocation(s_etat_processus, LST)) == NULL)
		{
			(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
			return;
		}

		/*
		 * Matrice d'entiers
		 */

		if ((*s_objet_argument_1).type == MIN)
		{
			max_entier = ((integer8 **) (*((struct_matrice *)
					(*s_objet_argument_1).objet)).tableau)[0][0];
			position_max_i = 0;
			position_max_j = 0;

			for(i = 0; i < (*((struct_matrice *) (*s_objet_argument_1).objet))
					.nombre_lignes; i++)
			{
				for(j = 0; j < (*((struct_matrice *) (*s_objet_argument_1)
						.objet)).nombre_colonnes; j++)
				{
					if (((integer8 **) (*((struct_matrice *)
							(*s_objet_argument_1).objet)).tableau)[i][j] >
							max_entier)
					{
						max_entier = ((integer8 **) (*((struct_matrice *)
								(*s_objet_argument_1).objet)).tableau)[i][j];
						position_max_i = i;
						position_max_j = j;
					}
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, INT))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*s_objet_resultat).objet)) = max_entier;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_i + 1;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_j + 1;
		}

		/*
		 * Matrice de rels
		 */

		else if ((*s_objet_argument_1).type == MRL)
		{
			max_reel = ((real8 **) (*((struct_matrice *)
					(*s_objet_argument_1).objet)).tableau)[0][0];
			position_max_i = 0;
			position_max_j = 0;

			for(i = 0; i < (*((struct_matrice *) (*s_objet_argument_1).objet))
					.nombre_lignes; i++)
			{
				for(j = 0; j < (*((struct_matrice *) (*s_objet_argument_1)
						.objet)).nombre_colonnes; j++)
				{
					if (((real8 **) (*((struct_matrice *)
							(*s_objet_argument_1).objet)).tableau)[i][j] >
							max_reel)
					{
						max_reel = ((real8 **) (*((struct_matrice *)
								(*s_objet_argument_1).objet)).tableau)[i][j];
						position_max_i = i;
						position_max_j = j;
					}
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, REL))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((real8 *) (*s_objet_resultat).objet)) = max_reel;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_i + 1;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_j + 1;
		}

		/*
		 * Matrice de complexes
		 */

		else
		{
			f77absc_(&(((struct_complexe16 **) (*((struct_matrice *)
					(*s_objet_argument_1).objet)).tableau)[0][0]), &max_reel);

			position_max_i = 0;
			position_max_j = 0;

			for(i = 0; i < (*((struct_matrice *) (*s_objet_argument_1).objet))
					.nombre_lignes; i++)
			{
				for(j = 0; j < (*((struct_matrice *) (*s_objet_argument_1)
						.objet)).nombre_colonnes; j++)
				{

					f77absc_(&(((struct_complexe16 **) (*((struct_matrice *)
							(*s_objet_argument_1).objet)).tableau)[i][j]),
							&module);

					if (module > max_reel)
					{
						max_reel = module;
						position_max_i = i;
						position_max_j = j;
					}
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, CPL))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_complexe16 *) (*s_objet_resultat).objet))
					.partie_reelle = ((struct_complexe16 **)
					(*((struct_matrice *) (*s_objet_argument_1).objet))
					.tableau)[position_max_i][position_max_j].partie_reelle;
			(*((struct_complexe16 *) (*s_objet_resultat).objet))
					.partie_imaginaire = ((struct_complexe16 **)
					(*((struct_matrice *) (*s_objet_argument_1).objet))
					.tableau)[position_max_i][position_max_j].partie_imaginaire;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_i + 1;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_max_j + 1;
		}

		liberation(s_etat_processus, s_objet_argument_1);

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_resultat) == d_erreur)
		{
			return;
		}

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_position) == d_erreur)
		{
			return;
		}
	}

/*
--------------------------------------------------------------------------------
  MAX portant sur autre chose (deux arguments)
--------------------------------------------------------------------------------
*/

	else
	{
		if (test_cfsf(s_etat_processus, 31) == d_vrai)
		{
			if (empilement_pile_last(s_etat_processus, 2) == d_erreur)
			{
				return;
			}
		}

		if (depilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				&s_objet_argument_1) == d_erreur)
		{
			(*s_etat_processus).erreur_execution = d_ex_manque_argument;
			return;
		}

		if (depilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				&s_objet_argument_2) == d_erreur)
		{
			liberation(s_etat_processus, s_objet_argument_1);

			(*s_etat_processus).erreur_execution = d_ex_manque_argument;
			return;
		}

/*
--------------------------------------------------------------------------------
  MAX portant sur des valeurs numriques
--------------------------------------------------------------------------------
*/

		if ((((*s_objet_argument_1).type == INT) ||
				((*s_objet_argument_1).type == REL)) &&
				(((*s_objet_argument_2).type == INT) ||
				((*s_objet_argument_2).type == REL)))
		{
			if ((*s_objet_argument_1).type == INT)
			{
				if ((*s_objet_argument_2).type == INT)
				{
					if ((*((integer8 *) (*s_objet_argument_1).objet)) >=
							(*((integer8 *) (*s_objet_argument_2).objet)))
					{
						s_objet_resultat = s_objet_argument_1;
						s_objet_argument_1 = NULL;
					}
					else
					{
						s_objet_resultat = s_objet_argument_2;
						s_objet_argument_2 = NULL;
					}
				}
				else
				{
					if ((*((integer8 *) (*s_objet_argument_1).objet)) >=
							(*((real8 *) (*s_objet_argument_2).objet)))
					{
						s_objet_resultat = s_objet_argument_1;
						s_objet_argument_1 = NULL;
					}
					else
					{
						s_objet_resultat = s_objet_argument_2;
						s_objet_argument_2 = NULL;
					}
				}
			}
			else
			{
				if ((*s_objet_argument_2).type == INT)
				{
					if ((*((real8 *) (*s_objet_argument_1).objet)) >=
							(*((integer8 *) (*s_objet_argument_2).objet)))
					{
						s_objet_resultat = s_objet_argument_1;
						s_objet_argument_1 = NULL;
					}
					else
					{
						s_objet_resultat = s_objet_argument_2;
						s_objet_argument_2 = NULL;
					}
				}
				else
				{
					if ((*((real8 *) (*s_objet_argument_1).objet)) >=
							(*((real8 *) (*s_objet_argument_2).objet)))
					{
						s_objet_resultat = s_objet_argument_1;
						s_objet_argument_1 = NULL;
					}
					else
					{
						s_objet_resultat = s_objet_argument_2;
						s_objet_argument_2 = NULL;
					}
				}
			}
		}

/*
--------------------------------------------------------------------------------
   MAX entre des arguments complexes
--------------------------------------------------------------------------------
*/

		/*
		 * Nom ou valeur numrique / Nom ou valeur numrique
		 */

		else if ((((*s_objet_argument_1).type == NOM) &&
				(((*s_objet_argument_2).type == NOM) ||
				((*s_objet_argument_2).type == INT) ||
				((*s_objet_argument_2).type == REL))) ||
				(((*s_objet_argument_2).type == NOM) &&
				(((*s_objet_argument_1).type == INT) ||
				((*s_objet_argument_1).type == REL))))
		{
			if ((s_objet_resultat = allocation(s_etat_processus, ALG))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			if (((*s_objet_resultat).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_resultat).objet;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nombre_arguments = 0;
			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.fonction = instruction_vers_niveau_superieur;

			if (((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction = malloc(3 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction, "<<");

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).donnee = s_objet_argument_2;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).donnee = s_objet_argument_1;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nombre_arguments = 2;
			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.fonction = instruction_max;

			if (((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction = malloc(4 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction, "MAX");

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nombre_arguments = 0;
			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.fonction = instruction_vers_niveau_inferieur;

			if (((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction = malloc(3 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction, ">>");

			(*l_element_courant).suivant = NULL;

			s_objet_argument_1 = NULL;
			s_objet_argument_2 = NULL;
		}

		/*
		 * Nom ou valeur numrique / Expression
		 */

		else if (((((*s_objet_argument_1).type == ALG) ||
				((*s_objet_argument_1).type == RPN))) &&
				(((*s_objet_argument_2).type == NOM) ||
				((*s_objet_argument_2).type == INT) ||
				((*s_objet_argument_2).type == REL)))
		{
			nombre_elements = 0;
			l_element_courant = (struct_liste_chainee *)
					(*s_objet_argument_1).objet;

			while(l_element_courant != NULL)
			{
				nombre_elements++;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (nombre_elements == 2)
			{
				liberation(s_etat_processus, s_objet_argument_1);
				liberation(s_etat_processus, s_objet_argument_2);

				(*s_etat_processus).erreur_execution = d_ex_argument_invalide;
				return;
			}

			if ((s_objet_resultat = copie_objet(s_etat_processus,
					s_objet_argument_1, 'N')) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (struct_liste_chainee *)
					(*s_objet_resultat).objet;
			l_element_precedent = l_element_courant;
			l_element_courant = (*l_element_courant).suivant;

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*(*l_element_precedent).suivant).donnee = s_objet_argument_2;
			(*(*l_element_precedent).suivant).suivant = l_element_courant;

			while((*l_element_courant).suivant != NULL)
			{
				l_element_precedent = l_element_courant;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			if (((*(*l_element_precedent).suivant).donnee =
					allocation(s_etat_processus, FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).nombre_arguments = 2;
			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).fonction = instruction_max;

			if (((*((struct_fonction *) (*(*(*l_element_precedent)
					.suivant).donnee).objet)).nom_fonction =
					malloc(4 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*(*l_element_precedent)
					.suivant).donnee).objet)).nom_fonction, "MAX");

			(*(*l_element_precedent).suivant).suivant = l_element_courant;

			s_objet_argument_2 = NULL;
		}

		/*
		 * Expression / Nom ou valeur numrique
		 */

		else if ((((*s_objet_argument_1).type == NOM) ||
				((*s_objet_argument_1).type == INT) ||
				((*s_objet_argument_1).type == REL)) &&
				((((*s_objet_argument_2).type == ALG) ||
				((*s_objet_argument_2).type == RPN))))
		{
			nombre_elements = 0;
			l_element_courant = (struct_liste_chainee *)
					(*s_objet_argument_2).objet;

			while(l_element_courant != NULL)
			{
				nombre_elements++;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (nombre_elements == 2)
			{
				liberation(s_etat_processus, s_objet_argument_1);
				liberation(s_etat_processus, s_objet_argument_2);

				(*s_etat_processus).erreur_execution = d_ex_argument_invalide;
				return;
			}

			if ((s_objet_resultat = copie_objet(s_etat_processus,
					s_objet_argument_2, 'N')) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (struct_liste_chainee *)
					(*s_objet_resultat).objet;
			l_element_precedent = l_element_courant;

			while((*l_element_courant).suivant != NULL)
			{
				l_element_precedent = l_element_courant;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*(*l_element_precedent).suivant).donnee = s_objet_argument_1;
			l_element_precedent = (*l_element_precedent).suivant;

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			if (((*(*l_element_precedent).suivant).donnee =
					allocation(s_etat_processus, FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).nombre_arguments = 2;
			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).fonction = instruction_max;

			if (((*((struct_fonction *) (*(*(*l_element_precedent)
					.suivant).donnee).objet)).nom_fonction =
					malloc(4 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*(*l_element_precedent)
					.suivant).donnee).objet)).nom_fonction, "MAX");

			(*(*l_element_precedent).suivant).suivant = l_element_courant;

			s_objet_argument_1 = NULL;
		}

		/*
		 * Expression / Expression
		 */

		else if ((((*s_objet_argument_1).type == ALG) &&
				((*s_objet_argument_2).type == ALG)) ||
				(((*s_objet_argument_1).type == RPN) &&
				((*s_objet_argument_2).type == RPN)))
		{
			nombre_elements = 0;
			l_element_courant = (struct_liste_chainee *)
					(*s_objet_argument_1).objet;

			while(l_element_courant != NULL)
			{
				nombre_elements++;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (nombre_elements == 2)
			{
				liberation(s_etat_processus, s_objet_argument_1);
				liberation(s_etat_processus, s_objet_argument_2);

				(*s_etat_processus).erreur_execution = d_ex_argument_invalide;
				return;
			}

			nombre_elements = 0;
			l_element_courant = (struct_liste_chainee *)
					(*s_objet_argument_2).objet;

			while(l_element_courant != NULL)
			{
				nombre_elements++;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (nombre_elements == 2)
			{
				liberation(s_etat_processus, s_objet_argument_1);
				liberation(s_etat_processus, s_objet_argument_2);

				(*s_etat_processus).erreur_execution = d_ex_argument_invalide;
				return;
			}

			if ((s_copie_argument_1 = copie_objet(s_etat_processus,
					s_objet_argument_1, 'N')) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			if ((s_copie_argument_2 = copie_objet(s_etat_processus,
					s_objet_argument_2, 'N')) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (struct_liste_chainee *)
					(*s_copie_argument_1).objet;
			(*s_copie_argument_1).objet = (void *) (*((struct_liste_chainee *)
					(*s_copie_argument_1).objet)).suivant;

			liberation(s_etat_processus, (*l_element_courant).donnee);
			free(l_element_courant);

			l_element_courant = (struct_liste_chainee *)
					(*s_copie_argument_2).objet;
			l_element_precedent = l_element_courant;
			s_objet_resultat = s_copie_argument_2;

			while((*l_element_courant).suivant != NULL)
			{
				l_element_precedent = l_element_courant;
				l_element_courant = (*l_element_courant).suivant;
			}

			liberation(s_etat_processus, (*l_element_courant).donnee);
			free(l_element_courant);

			(*l_element_precedent).suivant = (struct_liste_chainee *)
					(*s_copie_argument_1).objet;
			free(s_copie_argument_1);

			l_element_courant = (*l_element_precedent).suivant;
			while((*l_element_courant).suivant != NULL)
			{
				l_element_precedent = l_element_courant;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*(*l_element_precedent).suivant).suivant = l_element_courant;
			l_element_courant = (*l_element_precedent).suivant;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nombre_arguments = 2;
			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.fonction = instruction_max;

			if (((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction = malloc(4 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction, "MAX");
		}

/*
--------------------------------------------------------------------------------
  Arguments incorrects
--------------------------------------------------------------------------------
*/

		else
		{
			liberation(s_etat_processus, s_objet_argument_1);
			liberation(s_etat_processus, s_objet_argument_2);

			(*s_etat_processus).erreur_execution = d_ex_erreur_type_argument;
			return;
		}

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_resultat) == d_erreur)
		{
			return;
		}

		liberation(s_etat_processus, s_objet_argument_1);
		liberation(s_etat_processus, s_objet_argument_2);
	}

	return;
}


/*
================================================================================
  Fonction 'min'
================================================================================
  Entres :
--------------------------------------------------------------------------------
  Sorties :
--------------------------------------------------------------------------------
  Effets de bord : nant
================================================================================
*/

void
instruction_min(struct_processus *s_etat_processus)
{
	real8						min_reel;
	real8						module;

	integer8					min_entier;

	struct_liste_chainee		*l_element_courant;
	struct_liste_chainee		*l_element_precedent;

	struct_objet				*s_copie_argument_1;
	struct_objet				*s_copie_argument_2;
	struct_objet				*s_objet_argument_1;
	struct_objet				*s_objet_argument_2;
	struct_objet				*s_objet_position;
	struct_objet				*s_objet_resultat;

	integer8					i;
	integer8					j;
	integer8					nombre_elements;
	integer8					position_min_i;
	integer8					position_min_j;

	(*s_etat_processus).erreur_execution = d_ex;

	if ((*s_etat_processus).affichage_arguments == 'Y')
	{
		printf("\n  MIN ");

		if ((*s_etat_processus).langue == 'F')
		{
			printf("(minimum)\n\n");
		}
		else
		{
			printf("(minimum)\n\n");
		}

		printf("    1: %s, %s, %s\n", d_VIN, d_VRL, d_VCX);
		printf("->  2: %s, %s, %s\n", d_INT, d_REL, d_CPL);
		printf("    1: %s\n\n", d_LST);

		printf("    1: %s, %s, %s\n", d_MIN, d_MRL, d_MCX);
		printf("->  2: %s, %s, %s\n", d_INT, d_REL, d_CPL);
		printf("    1: %s\n\n", d_LST);

		printf("    2: %s, %s\n", d_INT, d_REL);
		printf("    1: %s, %s\n", d_INT, d_REL);
		printf("->  1: %s, %s\n\n", d_INT, d_REL);

		printf("    2: %s, %s, %s, %s, %s\n",
				d_INT, d_REL, d_NOM, d_ALG, d_RPN);
		printf("    1: %s, %s, %s, %s, %s\n",
				d_INT, d_REL, d_NOM, d_ALG, d_RPN);
		printf("->  1: %s, %s\n", d_ALG, d_RPN);

		return;
	}
	else if ((*s_etat_processus).test_instruction == 'Y')
	{
		(*s_etat_processus).nombre_arguments = 2;
		return;
	}

/*
--------------------------------------------------------------------------------
  MIN portant sur un tableau (un seul argument)
--------------------------------------------------------------------------------
*/

	if (((*(*(*s_etat_processus).l_base_pile).donnee).type == VIN)
			|| ((*(*(*s_etat_processus).l_base_pile).donnee).type ==
			VRL) || ((*(*(*s_etat_processus).l_base_pile)
			.donnee).type == VCX)) 
	{
		if (test_cfsf(s_etat_processus, 31) == d_vrai)
		{
			if (empilement_pile_last(s_etat_processus, 1) == d_erreur)
			{
				return;
			}
		}

		if (depilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				&s_objet_argument_1) == d_erreur)
		{
			(*s_etat_processus).erreur_execution = d_ex_manque_argument;
			return;
		}

		if ((s_objet_position = allocation(s_etat_processus, LST)) == NULL)
		{
			(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
			return;
		}

		/*
		 * Vecteur d'entiers
		 */

		if ((*s_objet_argument_1).type == VIN)
		{
			min_entier = ((integer8 *) (*((struct_vecteur *)
					(*s_objet_argument_1).objet)).tableau)[0];
			position_min_i = 0;

			for(i = 1; i < (*((struct_vecteur *) (*s_objet_argument_1).objet))
					.taille; i++)
			{
				if (((integer8 *) (*((struct_vecteur *) (*s_objet_argument_1)
						.objet)).tableau)[i] < min_entier)
				{
					min_entier = ((integer8 *) (*((struct_vecteur *)
							(*s_objet_argument_1).objet)).tableau)[i];
					position_min_i = i;
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, INT))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*s_objet_resultat).objet)) = min_entier;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_i + 1;
		}

		/*
		 * Vecteur de rels
		 */

		else if ((*s_objet_argument_1).type == VRL)
		{
			min_reel = ((real8 *) (*((struct_vecteur *)
					(*s_objet_argument_1).objet)).tableau)[0];
			position_min_i = 0;

			for(i = 1; i < (*((struct_vecteur *) (*s_objet_argument_1).objet))
					.taille; i++)
			{
				if (((real8 *) (*((struct_vecteur *) (*s_objet_argument_1)
						.objet)).tableau)[i] < min_reel)
				{
					min_reel = ((real8 *) (*((struct_vecteur *)
							(*s_objet_argument_1).objet)).tableau)[i];
					position_min_i = i;
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, REL))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((real8 *) (*s_objet_resultat).objet)) = min_reel;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_i + 1;
		}

		/*
		 * Vecteur de complexes
		 */

		else
		{
			f77absc_(&(((struct_complexe16 *) (*((struct_vecteur *)
					(*s_objet_argument_1).objet)).tableau)[0]), &min_reel);

			position_min_i = 0;

			for(i = 1; i < (*((struct_vecteur *) (*s_objet_argument_1).objet))
					.taille; i++)
			{
				f77absc_(&(((struct_complexe16 *) (*((struct_vecteur *)
						(*s_objet_argument_1).objet)).tableau)[i]), &module);

				if (module < min_reel)
				{
					min_reel = module;
					position_min_i = i;
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, CPL))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_complexe16 *) (*s_objet_resultat).objet))
					.partie_reelle = ((struct_complexe16 *)
					(*((struct_vecteur *) (*s_objet_argument_1).objet))
					.tableau)[position_min_i].partie_reelle;
			(*((struct_complexe16 *) (*s_objet_resultat).objet))
					.partie_imaginaire = ((struct_complexe16 *)
					(*((struct_vecteur *) (*s_objet_argument_1).objet))
					.tableau)[position_min_i].partie_imaginaire;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_i + 1;
		}

		liberation(s_etat_processus, s_objet_argument_1);

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_resultat) == d_erreur)
		{
			return;
		}

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_position) == d_erreur)
		{
			return;
		}
	}
	else if (((*(*(*s_etat_processus).l_base_pile).donnee).type ==
			MIN) || ((*(*(*s_etat_processus).l_base_pile)
			.donnee).type == MRL) || ((*(*(*s_etat_processus)
			.l_base_pile).donnee).type == MCX)) 
	{
		if (test_cfsf(s_etat_processus, 31) == d_vrai)
		{
			if (empilement_pile_last(s_etat_processus, 1) == d_erreur)
			{
				return;
			}
		}

		if (depilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				&s_objet_argument_1) == d_erreur)
		{
			(*s_etat_processus).erreur_execution = d_ex_manque_argument;
			return;
		}

		if ((s_objet_position = allocation(s_etat_processus, LST))
				== NULL)
		{
			(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
			return;
		}

		/*
		 * Matrice d'entiers
		 */

		if ((*s_objet_argument_1).type == MIN)
		{
			min_entier = ((integer8 **) (*((struct_matrice *)
					(*s_objet_argument_1).objet)).tableau)[0][0];
			position_min_i = 0;
			position_min_j = 0;

			for(i = 0; i < (*((struct_matrice *) (*s_objet_argument_1).objet))
					.nombre_lignes; i++)
			{
				for(j = 0; j < (*((struct_matrice *) (*s_objet_argument_1)
						.objet)).nombre_colonnes; j++)
				{
					if (((integer8 **) (*((struct_matrice *)
							(*s_objet_argument_1).objet)).tableau)[i][j] <
							min_entier)
					{
						min_entier = ((integer8 **) (*((struct_matrice *)
								(*s_objet_argument_1).objet)).tableau)[i][j];
						position_min_i = i;
						position_min_j = j;
					}
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, INT))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*s_objet_resultat).objet)) = min_entier;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_i + 1;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_j + 1;
		}

		/*
		 * Matrice de rels
		 */

		else if ((*s_objet_argument_1).type == MRL)
		{
			min_reel = ((real8 **) (*((struct_matrice *)
					(*s_objet_argument_1).objet)).tableau)[0][0];
			position_min_i = 0;
			position_min_j = 0;

			for(i = 0; i < (*((struct_matrice *) (*s_objet_argument_1).objet))
					.nombre_lignes; i++)
			{
				for(j = 0; j < (*((struct_matrice *) (*s_objet_argument_1)
						.objet)).nombre_colonnes; j++)
				{
					if (((real8 **) (*((struct_matrice *)
							(*s_objet_argument_1).objet)).tableau)[i][j] <
							min_reel)
					{
						min_reel = ((real8 **) (*((struct_matrice *)
								(*s_objet_argument_1).objet)).tableau)[i][j];
						position_min_i = i;
						position_min_j = j;
					}
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, REL))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((real8 *) (*s_objet_resultat).objet)) = min_reel;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_i + 1;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_j + 1;
		}

		/*
		 * Matrice de complexes
		 */

		else
		{
			f77absc_(&(((struct_complexe16 **) (*((struct_matrice *)
					(*s_objet_argument_1).objet)).tableau)[0][0]), &min_reel);

			position_min_i = 0;
			position_min_j = 0;

			for(i = 0; i < (*((struct_matrice *) (*s_objet_argument_1).objet))
					.nombre_lignes; i++)
			{
				for(j = 0; j < (*((struct_matrice *) (*s_objet_argument_1)
						.objet)).nombre_colonnes; j++)
				{

					f77absc_(&(((struct_complexe16 **) (*((struct_matrice *)
							(*s_objet_argument_1).objet)).tableau)[i][j]),
							&module);

					if (module < min_reel)
					{
						min_reel = module;
						position_min_i = i;
						position_min_j = j;
					}
				}
			}

			if ((s_objet_resultat = allocation(s_etat_processus, CPL))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_complexe16 *) (*s_objet_resultat).objet))
					.partie_reelle = ((struct_complexe16 **)
					(*((struct_matrice *) (*s_objet_argument_1).objet))
					.tableau)[position_min_i][position_min_j].partie_reelle;
			(*((struct_complexe16 *) (*s_objet_resultat).objet))
					.partie_imaginaire = ((struct_complexe16 **)
					(*((struct_matrice *) (*s_objet_argument_1).objet))
					.tableau)[position_min_i][position_min_j].partie_imaginaire;

			if (((*s_objet_position).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_position).objet;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_i + 1;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).suivant = NULL;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					INT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((integer8 *) (*(*l_element_courant).donnee).objet)) =
					position_min_j + 1;
		}

		liberation(s_etat_processus, s_objet_argument_1);

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_resultat) == d_erreur)
		{
			return;
		}

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_position) == d_erreur)
		{
			return;
		}
	}

/*
--------------------------------------------------------------------------------
  MIN portant sur autre chose (deux arguments)
--------------------------------------------------------------------------------
*/

	else
	{
		if (test_cfsf(s_etat_processus, 31) == d_vrai)
		{
			if (empilement_pile_last(s_etat_processus, 2) == d_erreur)
			{
				return;
			}
		}

		if (depilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				&s_objet_argument_1) == d_erreur)
		{
			(*s_etat_processus).erreur_execution = d_ex_manque_argument;
			return;
		}

		if (depilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				&s_objet_argument_2) == d_erreur)
		{
			liberation(s_etat_processus, s_objet_argument_1);

			(*s_etat_processus).erreur_execution = d_ex_manque_argument;
			return;
		}

/*
--------------------------------------------------------------------------------
  MIN portant sur des valeurs numriques
--------------------------------------------------------------------------------
*/

		if ((((*s_objet_argument_1).type == INT) ||
				((*s_objet_argument_1).type == REL)) &&
				(((*s_objet_argument_2).type == INT) ||
				((*s_objet_argument_2).type == REL)))
		{
			if ((*s_objet_argument_1).type == INT)
			{
				if ((*s_objet_argument_2).type == INT)
				{
					if ((*((integer8 *) (*s_objet_argument_1).objet)) <=
							(*((integer8 *) (*s_objet_argument_2).objet)))
					{
						s_objet_resultat = s_objet_argument_1;
						s_objet_argument_1 = NULL;
					}
					else
					{
						s_objet_resultat = s_objet_argument_2;
						s_objet_argument_2 = NULL;
					}
				}
				else
				{
					if ((*((integer8 *) (*s_objet_argument_1).objet)) <=
							(*((real8 *) (*s_objet_argument_2).objet)))
					{
						s_objet_resultat = s_objet_argument_1;
						s_objet_argument_1 = NULL;
					}
					else
					{
						s_objet_resultat = s_objet_argument_2;
						s_objet_argument_2 = NULL;
					}
				}
			}
			else
			{
				if ((*s_objet_argument_2).type == INT)
				{
					if ((*((real8 *) (*s_objet_argument_1).objet)) <=
							(*((integer8 *) (*s_objet_argument_2).objet)))
					{
						s_objet_resultat = s_objet_argument_1;
						s_objet_argument_1 = NULL;
					}
					else
					{
						s_objet_resultat = s_objet_argument_2;
						s_objet_argument_2 = NULL;
					}
				}
				else
				{
					if ((*((real8 *) (*s_objet_argument_1).objet)) <=
							(*((real8 *) (*s_objet_argument_2).objet)))
					{
						s_objet_resultat = s_objet_argument_1;
						s_objet_argument_1 = NULL;
					}
					else
					{
						s_objet_resultat = s_objet_argument_2;
						s_objet_argument_2 = NULL;
					}
				}
			}
		}

/*
--------------------------------------------------------------------------------
   MIN entre des arguments complexes
--------------------------------------------------------------------------------
*/

		/*
		 * Nom ou valeur numrique / Nom ou valeur numrique
		 */

		else if ((((*s_objet_argument_1).type == NOM) &&
				(((*s_objet_argument_2).type == NOM) ||
				((*s_objet_argument_2).type == INT) ||
				((*s_objet_argument_2).type == REL))) ||
				(((*s_objet_argument_2).type == NOM) &&
				(((*s_objet_argument_1).type == INT) ||
				((*s_objet_argument_1).type == REL))))
		{
			if ((s_objet_resultat = allocation(s_etat_processus, ALG))
					== NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			if (((*s_objet_resultat).objet =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*s_objet_resultat).objet;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nombre_arguments = 0;
			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.fonction = instruction_vers_niveau_superieur;

			if (((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction = malloc(3 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction, "<<");

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).donnee = s_objet_argument_2;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;
			(*l_element_courant).donnee = s_objet_argument_1;

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nombre_arguments = 2;
			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.fonction = instruction_min;

			if (((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction = malloc(4 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction, "MIN");

			if (((*l_element_courant).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (*l_element_courant).suivant;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nombre_arguments = 0;
			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.fonction = instruction_vers_niveau_inferieur;

			if (((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction = malloc(3 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction, ">>");

			(*l_element_courant).suivant = NULL;

			s_objet_argument_1 = NULL;
			s_objet_argument_2 = NULL;
		}

		/*
		 * Nom ou valeur numrique / Expression
		 */

		else if (((((*s_objet_argument_1).type == ALG) ||
				((*s_objet_argument_1).type == RPN))) &&
				(((*s_objet_argument_2).type == NOM) ||
				((*s_objet_argument_2).type == INT) ||
				((*s_objet_argument_2).type == REL)))
		{
			nombre_elements = 0;
			l_element_courant = (struct_liste_chainee *)
					(*s_objet_argument_1).objet;

			while(l_element_courant != NULL)
			{
				nombre_elements++;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (nombre_elements == 2)
			{
				liberation(s_etat_processus, s_objet_argument_1);
				liberation(s_etat_processus, s_objet_argument_2);

				(*s_etat_processus).erreur_execution = d_ex_argument_invalide;
				return;
			}

			if ((s_objet_resultat = copie_objet(s_etat_processus,
					s_objet_argument_1, 'N')) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (struct_liste_chainee *)
					(*s_objet_resultat).objet;
			l_element_precedent = l_element_courant;
			l_element_courant = (*l_element_courant).suivant;

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*(*l_element_precedent).suivant).donnee = s_objet_argument_2;
			(*(*l_element_precedent).suivant).suivant = l_element_courant;

			while((*l_element_courant).suivant != NULL)
			{
				l_element_precedent = l_element_courant;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			if (((*(*l_element_precedent).suivant).donnee =
					allocation(s_etat_processus, FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).nombre_arguments = 2;
			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).fonction = instruction_min;

			if (((*((struct_fonction *) (*(*(*l_element_precedent)
					.suivant).donnee).objet)).nom_fonction =
					malloc(4 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*(*l_element_precedent)
					.suivant).donnee).objet)).nom_fonction, "MIN");

			(*(*l_element_precedent).suivant).suivant = l_element_courant;

			s_objet_argument_2 = NULL;
		}

		/*
		 * Expression / Nom ou valeur numrique
		 */

		else if ((((*s_objet_argument_1).type == NOM) ||
				((*s_objet_argument_1).type == INT) ||
				((*s_objet_argument_1).type == REL)) &&
				((((*s_objet_argument_2).type == ALG) ||
				((*s_objet_argument_2).type == RPN))))
		{
			nombre_elements = 0;
			l_element_courant = (struct_liste_chainee *)
					(*s_objet_argument_2).objet;

			while(l_element_courant != NULL)
			{
				nombre_elements++;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (nombre_elements == 2)
			{
				liberation(s_etat_processus, s_objet_argument_1);
				liberation(s_etat_processus, s_objet_argument_2);

				(*s_etat_processus).erreur_execution = d_ex_argument_invalide;
				return;
			}

			if ((s_objet_resultat = copie_objet(s_etat_processus,
					s_objet_argument_2, 'N')) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (struct_liste_chainee *)
					(*s_objet_resultat).objet;
			l_element_precedent = l_element_courant;

			while((*l_element_courant).suivant != NULL)
			{
				l_element_precedent = l_element_courant;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*(*l_element_precedent).suivant).donnee = s_objet_argument_1;
			l_element_precedent = (*l_element_precedent).suivant;

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			if (((*(*l_element_precedent).suivant).donnee =
					allocation(s_etat_processus, FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).nombre_arguments = 2;
			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).fonction = instruction_min;

			if (((*((struct_fonction *) (*(*(*l_element_precedent)
					.suivant).donnee).objet)).nom_fonction =
					malloc(4 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*(*l_element_precedent)
					.suivant).donnee).objet)).nom_fonction, "MIN");

			(*(*l_element_precedent).suivant).suivant = l_element_courant;

			s_objet_argument_1 = NULL;
		}

		/*
		 * Expression / Expression
		 */

		else if ((((*s_objet_argument_1).type == ALG) &&
				((*s_objet_argument_2).type == ALG)) ||
				(((*s_objet_argument_1).type == RPN) &&
				((*s_objet_argument_2).type == RPN)))
		{
			nombre_elements = 0;
			l_element_courant = (struct_liste_chainee *)
					(*s_objet_argument_1).objet;

			while(l_element_courant != NULL)
			{
				nombre_elements++;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (nombre_elements == 2)
			{
				liberation(s_etat_processus, s_objet_argument_1);
				liberation(s_etat_processus, s_objet_argument_2);

				(*s_etat_processus).erreur_execution = d_ex_argument_invalide;
				return;
			}

			nombre_elements = 0;
			l_element_courant = (struct_liste_chainee *)
					(*s_objet_argument_2).objet;

			while(l_element_courant != NULL)
			{
				nombre_elements++;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (nombre_elements == 2)
			{
				liberation(s_etat_processus, s_objet_argument_1);
				liberation(s_etat_processus, s_objet_argument_2);

				(*s_etat_processus).erreur_execution = d_ex_argument_invalide;
				return;
			}

			if ((s_copie_argument_1 = copie_objet(s_etat_processus,
					s_objet_argument_1, 'N')) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			if ((s_copie_argument_2 = copie_objet(s_etat_processus,
					s_objet_argument_2, 'N')) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			l_element_courant = (struct_liste_chainee *)
					(*s_copie_argument_1).objet;
			(*s_copie_argument_1).objet = (void *) (*((struct_liste_chainee *)
					(*s_copie_argument_1).objet)).suivant;

			liberation(s_etat_processus, (*l_element_courant).donnee);
			free(l_element_courant);

			l_element_courant = (struct_liste_chainee *)
					(*s_copie_argument_2).objet;
			l_element_precedent = l_element_courant;
			s_objet_resultat = s_copie_argument_2;

			while((*l_element_courant).suivant != NULL)
			{
				l_element_precedent = l_element_courant;
				l_element_courant = (*l_element_courant).suivant;
			}

			liberation(s_etat_processus, (*l_element_courant).donnee);
			free(l_element_courant);

			(*l_element_precedent).suivant = (struct_liste_chainee *)
					(*s_copie_argument_1).objet;
			free(s_copie_argument_1);

			l_element_courant = (*l_element_precedent).suivant;
			while((*l_element_courant).suivant != NULL)
			{
				l_element_precedent = l_element_courant;
				l_element_courant = (*l_element_courant).suivant;
			}

			if (((*l_element_precedent).suivant =
					allocation_maillon(s_etat_processus)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*(*l_element_precedent).suivant).suivant = l_element_courant;
			l_element_courant = (*l_element_precedent).suivant;

			if (((*l_element_courant).donnee = allocation(s_etat_processus,
					FCT)) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			(*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nombre_arguments = 2;
			(*((struct_fonction *) (*(*(*l_element_precedent).suivant)
					.donnee).objet)).fonction = instruction_min;

			if (((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction = malloc(4 * sizeof(unsigned char))) == NULL)
			{
				(*s_etat_processus).erreur_systeme = d_es_allocation_memoire;
				return;
			}

			strcpy((*((struct_fonction *) (*(*l_element_courant).donnee).objet))
					.nom_fonction, "MIN");
		}

/*
--------------------------------------------------------------------------------
  Arguments incorrects
--------------------------------------------------------------------------------
*/

		else
		{
			liberation(s_etat_processus, s_objet_argument_1);
			liberation(s_etat_processus, s_objet_argument_2);

			(*s_etat_processus).erreur_execution = d_ex_erreur_type_argument;
			return;
		}

		if (empilement(s_etat_processus, &((*s_etat_processus).l_base_pile),
				s_objet_resultat) == d_erreur)
		{
			return;
		}

		liberation(s_etat_processus, s_objet_argument_1);
		liberation(s_etat_processus, s_objet_argument_2);
	}

	return;
}

// vim: ts=4
