!===============================================================================
! RPL/2 (R) version 4.1.21
! Copyright (C) 1989-2015 Dr. BERTRAND Jol
!
! This file is part of RPL/2.
!
! RPL/2 is free software; you can redistribute it and/or modify it
! under the terms of the CeCILL V2 License as published by the french
! CEA, CNRS and INRIA.
!
! RPL/2 is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
! FITNESS FOR A PARTICULAR PURPOSE.  See the CeCILL V2 License
! for more details.
!
! You should have received a copy of the CeCILL License
! along with RPL/2. If not, write to info@cecill.info.
!===============================================================================


#ifndef INCLUSION_RPLFTYPES
#	define INCLUSION_RPLFTYPES

#	ifdef RPLCONFIG
#		define HAVE_CONFIG_H
#	endif

#	ifdef HAVE_CONFIG_H

#		include "rplconfig.h"

#		if (SIZEOF_CHAR == 1)
#			ifndef _INT1
#				define _INT1
#				define rpl_char					C_CHAR
#			endif
#		endif

#		if (SIZEOF_SHORT_INT == 2)
#			ifndef _INT2
#				define _INT2
#				define rpl_integer2				C_SHORT
#			endif
#		endif

#		if (SIZEOF_INT == 4)
#			ifndef _INT4
#				define _INT4
#				define rpl_integer4				C_INT
#			endif
#		endif

#		if (SIZEOF_LONG_INT == 4)
#			ifndef _INT4
#				define _INT4
#				define rpl_integer4				C_LONG
#			endif
#		endif

#		if (SIZEOF_LONG_INT == 8)
#			ifndef _INT8
#				define _INT8
#				define rpl_integer8				C_LONG
#			endif
#		endif

#		if (SIZEOF_LONG_LONG_INT == 8)
#			ifndef _INT8
#				define _INT8
#				define rpl_integer8				C_LONG_LONG
#			endif
#		endif

#		if (SIZEOF_FLOAT == 4)
#			ifndef _REAL4
#				define _REAL4
#				define rpl_real4				C_FLOAT
#			endif
#		endif

#		if (SIZEOF_DOUBLE == 8)
#			ifndef _REAL8
#				define _REAL8
#				define rpl_real8				C_DOUBLE
#			endif
#		endif

#		if (SIZEOF_LONG_DOUBLE == 8)
#			ifndef _REAL8
#				define _REAL8
#				define rpl_real8				C_LONG_DOUBLE
#			endif
#		endif

#		ifndef _INT1
#			error "INTEGER*1 is not defined !"
#		endif

#		ifndef _INT2
#			error "INTEGER*2 is not defined !"
#		endif

#		ifndef _INT4
#			error "INTEGER*4 is not defined !"
#		endif

#		ifndef _INT8
#			error "INTEGER*8 is not defined !"
#		endif

#		ifndef _REAL4
#			error "REAL*4 is not defined !"
#		endif

#		ifndef _REAL8
#			error "REAL*8 is not defined !"
#		endif
#	else
#		error "rplconfig.h header not found !"
#	endif

	module rpl_complex
		use iso_c_binding
		implicit none

		type rpl_complex8
			sequence
			real(rpl_real4)	partie_reelle
			real(rpl_real4)	partie_imaginaire
		end type

		type rpl_complex16
			sequence
			real(rpl_real8)	partie_reelle
			real(rpl_real8)	partie_imaginaire
		end type
	end module
#endif

! vim: ts=4
